/* Copyright ? 2005, Stylegraph, Inc.  All rights reserved. */
var flgSearchAddress;
var flgSearchOffice;
var flgContentsVisible = false;
var intContentsHeight = 0;
var intMaxContentsHeight = 136;
var timerContents;
var infoVisible = false;
var fade = { duration: 500, startTime: 0, to: 1.0, now: 0.0, from: 0.0, timer: null, frameRate: 13 };

function loadWidget() {
	if (widget) {
		widget.onremove = removeWidget;
		if (widget.preferenceForKey(widget.identifier + '-AddressData') == null) {
			widget.setPreferenceForKey(true, widget.identifier + '-AddressData');
		}
		if (widget.preferenceForKey(widget.identifier + '-OfficeData') == null) {
			widget.setPreferenceForKey(false, widget.identifier + '-OfficeData');
		}
		flgSearchAddress = widget.preferenceForKey(widget.identifier + '-AddressData');
		flgSearchOffice = widget.preferenceForKey(widget.identifier + '-OfficeData');
	}
	var infoButton = new AppleInfoButton(document.getElementById('Info'), document.getElementById('Front'), 'black', 'black', clickInfo);
	var doneButton = new AppleGlassButton (document.getElementById('Done'), '完了', clickDone);
	document.getElementById('AddressData').checked = flgSearchAddress;
	document.getElementById('OfficeData').checked = flgSearchOffice;
}

function removeWidget() {
	if (widget) {
		widget.setPreferenceForKey(null, widget.identifier + '-AddressData');
		widget.setPreferenceForKey(null, widget.identifier + '-OfficeData');
	}
}

function searchAddress(strKeyword) {
	if (widget && strKeyword.length) {
		var intHitCount = 0;
		var intAddressHitCount = 0;
		var intOfficeHitCount = 0;
		var aryResult = new Array;

		document.getElementById('ContentsTop').style.display = 'block';
		document.getElementById('Contents').style.display = 'block';
		document.getElementById('StatusBar').style.display = 'block';
		document.getElementById('Result').style.top = '0px';
		flgContentsVisible = true;
		startTimer();

		strKeyword = widget.system("/bin/echo -n '" + strKeyword + "' | /usr/bin/iconv -f UTF8 -t UTF8-MAC", null).outputString;
		strKeyword = convertZenkakuToHankaku(strKeyword);
		strKeyword = strKeyword.replace("'", "\'");
		if (flgSearchAddress) intAddressHitCount = parseInt(widget.system("/usr/bin/grep -aci '" + strKeyword + "' AddressData.tsv", null).outputString);
		if (flgSearchOffice) intOfficeHitCount += parseInt(widget.system("/usr/bin/grep -aci '" + strKeyword + "' OfficeData.tsv", null).outputString);
		intHitCount = intAddressHitCount + intOfficeHitCount;
		if (intHitCount > 35) {
			document.getElementById('Result').innerHTML = '検索結果が35件を超えています。<br />キーワードを続けて入力してください。';
			setStatus(intHitCount + '件見つかりました。');
		} else if (intHitCount > 0) {
			document.getElementById("Result").innerHTML = "";
			setStatus('検索中...');
			if (intAddressHitCount > 0) {
				aryResult = widget.system("/usr/bin/grep -ai '" + strKeyword + "' AddressData.tsv", null).outputString.split("\n");
				for (i = 0; i < aryResult.length - 1; i++) {
					aryAddress = aryResult[i].split("\t");
					document.getElementById("Result").innerHTML += '〒<span class="Result" onclick="copyToClipboard(this)">' + aryAddress[0] + '</span><br />';
					document.getElementById("Result").innerHTML += '<span class="Result Kana" onclick="copyToClipboard(this)">' + aryAddress[2] + '</span><br />';
					document.getElementById("Result").innerHTML += '<span class="Result" onclick="copyToClipboard(this)">' + aryAddress[1] + '</span>';
					document.getElementById("Result").innerHTML += ' <span class="Map" onclick="openUrl(\'http://maps.google.co.jp/maps?output=html&q=' + aryAddress[1] + '\')"></span><br /><br />';
				}
			}
			if (intOfficeHitCount > 0) {
				aryResult = widget.system("/usr/bin/grep -ai '" + strKeyword + "' OfficeData.tsv", null).outputString.split("\n");
				for (i = 0; i < aryResult.length - 1; i++) {
					aryAddress = aryResult[i].split("\t");
					document.getElementById("Result").innerHTML += '〒<span class="Result" onclick="copyToClipboard(this)">' + aryAddress[0] + '</span><br />';
					document.getElementById("Result").innerHTML += '<span class="Result Kana" onclick="copyToClipboard(this)">' + aryAddress[2] + '</span><br />';
					document.getElementById("Result").innerHTML += '<span class="Result" onclick="copyToClipboard(this)">' + aryAddress[3] + '</span>';
					document.getElementById("Result").innerHTML += ' <img src="Images/Map.png" width="22" height="12" class="Map" onclick="openUrl(\'http://maps.google.co.jp/maps?output=html&q=' + aryAddress[1] + '\')" /><br /><br />';
				}
			}
			setStatus(intHitCount + '件見つかりました。');
		} else {
			document.getElementById('Result').innerHTML = '該当する住所はございません。<br />他のキーワードでお試しください。';
			setStatus('見つかりませんでした。');
		}
		calculateAndShowThumb(document.getElementById("Result"));
		document.getElementById("ScrollBar").style.visibility = "visible";
	} else {
		document.getElementById("Status").innerHTML = "";
		document.getElementById("Result").innerHTML = "";
		document.getElementById("ScrollBar").style.visibility = "hidden";
		flgContentsVisible = false;
		startTimer();
	}
}

function startTimer() {
	if (timerContents == null) {
		timerContents = setInterval("updateSize()", 5);
	}
}

function stopTimer() {
	if (timerContents != null) {
		clearInterval(timerContents);
		timerContents = null;
	}
}

function updateSize() {
	if (flgContentsVisible) {
		intContentsHeight += 34;
		if (intContentsHeight >= intMaxContentsHeight) {
			intContentsHeight = intMaxContentsHeight;
			stopTimer();
		}
	} else {
		intContentsHeight -= 34;
		if (intContentsHeight < 0) {
			intContentsHeight = 0;
			document.getElementById("StatusBar").style.display = "none";
			document.getElementById("Contents").style.display = "none";
			document.getElementById("ContentsTop").style.display = "none";
			stopTimer();
		}
	}

	document.getElementById("Contents").style.height = intContentsHeight;
	document.getElementById("StatusBar").style.top = 20 + intContentsHeight;
	if (widget) resizeTo(300, intContentsHeight + 49);
}

function copyToClipboard(objElement) {
	if (widget) {
		document.getElementById("Contents").style.cursor = "wait";
		setStatus("クリップボードにコピー中...");
		widget.system("/bin/echo -n '" + objElement.innerText + "' | /usr/bin/iconv -f UTF8-MAC -t SHIFT_JIS | /usr/bin/pbcopy", null);
		objElement.style.color = "#999999";
		setStatus("クリップボードにコピーしました。");
		document.getElementById("Contents").style.cursor = "auto";
	}
}

function setStatus(strMessage) {
		document.getElementById("Status").innerHTML = strMessage;
}

function changeSearchData() {
	flgSearchAddress = document.getElementById("AddressData").checked;
	flgSearchOffice = document.getElementById("OfficeData").checked;
	if (widget) {
		widget.setPreferenceForKey(document.getElementById("AddressData").checked, widget.identifier + "-AddressData");
		widget.setPreferenceForKey(document.getElementById("OfficeData").checked, widget.identifier + "-OfficeData");
	}
}

function changeSearchDataCheckbox(target) {
	document.getElementById(target).checked = !document.getElementById(target).checked;
	changeSearchData();
}

function clickInfo() {
	if (widget) widget.prepareForTransition("ToBack");
	document.getElementById("Front").style.display = "none";
	document.getElementById("Back").style.display = "block";
	if (widget) setTimeout("widget.performTransition()", 0);
}

function clickDone() {
	if (widget) widget.prepareForTransition("ToFront");
	document.getElementById("Front").style.display = "block";
	document.getElementById("Back").style.display = "none";
	if (widget) setTimeout("widget.performTransition()", 0);
}

function openUrl(strUrl) {
	if (widget) widget.openURL(strUrl);
}

function convertZenkakuToHankaku(strOriginal) {
	var strReturn = "";
	var strZenkaku = "　０１２３４５６７８９−ー（）＠．。";
	var strHankaku = " 0123456789--()@..";
	var strCharactor;
	var intPosition;

	for (i = 0; i < strOriginal.length; i++) {
		strCharactor = strOriginal.charAt(i);
		intPosition = strZenkaku.indexOf(strCharactor);
		if (intPosition >= 0) strReturn += strHankaku.charAt(intPosition);
		else strReturn += strCharactor;
	}
	return strReturn;
}

/*
Copyright _ 2005, Apple Computer, Inc.  All rights reserved.
NOTE:  Use of this source code is subject to the terms of the Software
License Agreement for Mac OS X, which accompanies the code.  Your use
of this source code signifies your agreement to such license terms and
conditions.  Except as expressly granted in the Software License Agreement
for Mac OS X, no other copyright, patent, or other intellectual property
license or right is granted, either expressly or by implication, by Apple.
*/
var currentContent;
var currentContentStyle;
var scrollBar;
var scrollThumb;
var scrollTrack;
var trackTimer;
var currentContentHeight;
var currentContentTop;
var viewHeight;
var trackMouseY;
var thumbHeight;
var tracking = true;
var thumbStartY = -1;
var scrollThumbStartPos = -1;
var scrollBarHeight;
var numberOfScrollablePixels;
var SCROLLBAR_TOP = -1;
var SCROLL_THUMB_HEIGHT = 27;
var SCROLLBAR_DIV_NAME = "ScrollBar";
var SCROLLTHUMB_DIV_NAME = "ScrollThumb";
var SCROLLTRACK_DIV_NAME = "ScrollTrack";
var TRACK_TOP_DIV_NAME = "ScrollTrackTop";
var TRACK_MID_DIV_NAME = "ScrollTrackMiddle";
var TRACK_BOT_DIV_NAME = "ScrollTrackBottom";
var PAGE_SKIP_PAUSE = 150;

function calculateAndShowThumb(contentDiv) {

	scrollBar = document.getElementById(SCROLLBAR_DIV_NAME);
	scrollThumb = document.getElementById(SCROLLTHUMB_DIV_NAME);
	scrollTrack = document.getElementById(SCROLLTRACK_DIV_NAME);

	if (contentDiv != null) {
		currentContent = contentDiv;
	} else if (currentContent == null) {
		hideScrollbar();
	}

	currentContent.style.display = "block";
	currentContentStyle = document.defaultView.getComputedStyle(currentContent,"");
	currentContentTop = parseInt(currentContentStyle.getPropertyValue("top"));
	currentContentHeight = parseInt(currentContentStyle.getPropertyValue("height"));

	viewHeight = parseFloat (document.defaultView.getComputedStyle(currentContent.parentNode, "").getPropertyValue("height"));
	scrollBarHeight = parseInt(document.defaultView.getComputedStyle(scrollBar, "").getPropertyValue("height"));

	var percent = getProportion (viewHeight, currentContentHeight);

	if (percent == 0) {
		hideScrollBar();
	} else {
		thumbHeight = Math.max(Math.round(scrollBarHeight * percent), SCROLL_THUMB_HEIGHT);
		thumbTop = thumbPositionForPagePosition(currentContentTop);

		scrollThumb.style.height = thumbHeight + "px";
		scrollThumb.style.top = thumbTop;

		numberOfScrollablePixels = scrollBarHeight - thumbHeight - SCROLLBAR_TOP;

		scrollContent(thumbTop);
		showScrollBar();
	}
}

function hideScrollBar() {
	scrollTrack.style.display = "none";
	scrollThumb.style.display = "none";
}

function showScrollBar() {
	scrollTrack.style.display = "block";
	scrollThumb.style.display = "block";
}

function mouseDownScrollThumb(event) {
	document.addEventListener("mousemove", mouseMoveScrollThumb, true);
	document.addEventListener("mouseup", mouseUpScrollThumb, true);
	thumbStartY = event.y;
	scrollThumbStartPos = parseInt(document.defaultView.getComputedStyle(scrollThumb, "").getPropertyValue("top"));
}

function mouseMoveScrollThumb(event) {
	var deltaY = event.y - thumbStartY;
	var newPosition = scrollThumbStartPos + deltaY;
	scrollContent(newPosition);
}

function scrollContent(newThumbPosition) {
	if (newThumbPosition < SCROLLBAR_TOP) newThumbPosition = SCROLLBAR_TOP;
	else if ((newThumbPosition + thumbHeight) > scrollBarHeight) newThumbPosition = scrollBarHeight - thumbHeight;

	scrollThumb.style.top = newThumbPosition + "px";

	currentContentTop = pagePositionForThumbPosition(newThumbPosition);
	currentContent.style.top = currentContentTop + "px";
}

function mouseUpScrollThumb(event) {
	document.removeEventListener("mousemove", mouseMoveScrollThumb, true);
	document.removeEventListener("mouseup", mouseUpScrollThumb, true);
	thumbStartY = -1;
}

function mouseDownTrack(event) {
	updateTrackMouseY(event);

	scrollTrack.addEventListener("mousemove", mouseMoveTrack, false);
	scrollTrack.addEventListener("mouseover", mouseOverTrack, false);
	scrollTrack.addEventListener("mouseout", mouseOutTrack, false);

	var thumbTop = document.defaultView.getComputedStyle(scrollThumb,'').getPropertyValue('top');
	if (trackMouseY > parseInt(thumbTop)) {
		pageDown();
		trackTimer = setInterval("pageDown();", PAGE_SKIP_PAUSE);
	} else {
		pageUp();
		trackTimer = setInterval("pageUp();", PAGE_SKIP_PAUSE);
	}
}

function mouseMoveTrack(event) {
	updateTrackMouseY(event);
}

function mouseOutTrack(event) {
	tracking = false;
}

function mouseOverTrack(event) {
	tracking = true;
}

function mouseUpTrack(event) {
	clearInterval(trackTimer);

	scrollTrack.removeEventListener("mousemove", mouseMoveTrack, false);
	scrollTrack.removeEventListener("mouseover", mouseMoveTrack, false);
	scrollTrack.removeEventListener("mouseout", mouseMoveTrack, false);
}

function updateTrackMouseY(event) {
	if (event.toElement.id == "ScrollTrackMiddle") {
		var topHeight = document.defaultView.getComputedStyle(document.getElementById(TRACK_TOP_DIV_NAME)).getPropertyValue("height");
		trackMouseY = event.offsetY + parseInt(topHeight);
	} else if (event.toElement.id == TRACK_BOT_DIV_NAME) {
		var midHeight = document.defaultView.getComputedStyle(document.getElementById(TRACK_MID_DIV_NAME)).getPropertyValue("height");
		var topHeight = document.defaultView.getComputedStyle(document.getElementById(TRACK_TOP_DIV_NAME)).getPropertyValue("height");
		trackMouseY = event.offsetY + parseInt(midHeight) + parseInt(topHeight);
	} else {
		trackMouseY = event.offsetY - (event.toElement.offsetTop + event.toElement.parentNode.offsetTop);
	}
}

function pageDown() {
	if (!tracking) return;
	currentContentTop = parseInt(currentContentStyle.getPropertyValue("top"));
	var lastPageY = -(currentContentHeight - viewHeight);
	var nextPageY = currentContentTop - viewHeight;
	currentContentTop = Math.max(lastPageY, nextPageY);
	currentContent.style.top = currentContentTop + "px";

	var newThumbTop = thumbPositionForPagePosition(currentContentTop);
	var thumbBottom = newThumbTop + parseInt(scrollThumb.style.height);
	scrollThumb.style.top = newThumbTop;

	if (trackMouseY < thumbBottom) clearInterval(trackTimer);
}

function pageUp(){
	if (!tracking) return;
	currentContentTop = parseInt(currentContentStyle.getPropertyValue("top"));
	var firstPageY = 0;
	var nextPageY = currentContentTop + viewHeight;
	currentContentTop = Math.min(firstPageY, nextPageY)
	currentContent.style.top = currentContentTop + "px";

	var newThumbTop = thumbPositionForPagePosition(currentContentTop);
	scrollThumb.style.top = newThumbTop;

	if (trackMouseY > newThumbTop) clearInterval(trackTimer);
}

function getProportion(viewheight, documentheight) {
	if (documentheight <= viewheight) return 0;
	else return viewheight / documentheight;
}

function pagePositionForThumbPosition(thumbPosition) {
	return -(thumbPosition - SCROLLBAR_TOP) * ((currentContentHeight - viewHeight) / numberOfScrollablePixels);
}

function thumbPositionForPagePosition(pagePosition) {
	return -(pagePosition / ((currentContentHeight - viewHeight) / numberOfScrollablePixels)) + SCROLLBAR_TOP;
}
